%% targetadma.cls

%% targetadma 'es una classe de document per produir 
%% targetes de visita dels membres del DMA de la UPV
%%
%% Aquesta 'es la versi'o 1.1, (primera versi pblica)
%% del 10 de juliol de 2000
%% Copyright 2000 Robert Fuster (rfuster@mat.upv.es)
%%            and Josep Mas (jmasm@mat.upv.es)

%% It may be distributed and/or modified under the
%% conditions of the LaTeX Project Public License, either version 1.2
%% of this license or (at your option) any later version.
%% The latest version of this license is in
%%    http://www.latex-project.org/lppl.txt
%% and version 1.2 or later is part of all distributions of LaTeX
%% version 1999/12/01 or later.

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{targetadma}[2000/06/02 LaTeX2e class]

\DeclareOption{draft}{\def\prova{si}}
\DeclareOption{final}{\def\prova{no}}

\DeclareOption{vera}{\def\campus{vera}}
\DeclareOption{alcoi}{\def\campus{alcoi}}
\DeclareOption{blasco}{\def\campus{blasco}}
\DeclareOption{gandia}{\def\campus{gandia}}

\ExecuteOptions{final,vera}
\ProcessOptions

\RequirePackage{graphicx,color,ifthen,calc}
\RequirePackage[T1]{fontenc}
\RequirePackage{pandora}

\AtBeginDocument{\ifthenelse{\equal{\prova}{si}}{%
                   \definecolor{griset}{gray}{0.75}}{%
                   \definecolor{griset}{gray}{1}}}

\LoadClass[a4paper]{article}

\pagestyle{empty}

\setlength{\hoffset}{-1in}
\setlength{\topmargin}{16mm}
\setlength{\headheight}{0pt}
\setlength{\headsep}{0pt}

\setlength{\voffset}{-1in}
\setlength{\oddsidemargin}{15mm}
\setlength{\textheight}{28cm}

\newsavebox{\fminibox}
\newlength{\fminilength}
\setlength{\fminilength}{9cm}
\newcommand{\lample}{9}

\newlength{\fminiheight}
\setlength{\fminiheight}{5.1cm}
\newcommand{\lalt}{5.1}

\setlength{\parindent}{0pt}
\setlength{\fboxsep}{0pt}

\newenvironment{fminipage}
  {\begin{lrbox}{\fminibox}\begin{minipage}[t][\fminiheight]{\fminilength}}
  {\end{minipage}\end{lrbox}\noindent\color{griset}\fbox{\color{black}\usebox{\fminibox}}}

% Declaracions privades
\newcommand{\elnom}{}
\newcommand{\elcarrec}{}
\newcommand{\lemail}{}
\newcommand{\lurl}{}
\newcommand{\eltelefon}{}
\newcommand{\elfax}{}
\newcommand{\elcolornom}{\color{blue}}
\newcommand{\elcolorupvdma}{\color{black}}
\newcommand{\elcoloradreca}{\color{black}}
\newcommand{\elcentre}{}

% Declaracions pbliques
\newcommand{\nom}[1]{\renewcommand{\elnom}{#1}}
\newcommand{\carrec}[1]{\renewcommand{\elcarrec}{#1}}
\newcommand{\telefon}[1]{\renewcommand{\eltelefon}{#1}}
\newcommand{\fax}[1]{\renewcommand{\elfax}{#1}}
\newcommand{\email}[1]{\renewcommand{\lemail}{\texttt{#1}}}
\newcommand{\url}[1]{\renewcommand{\lurl}{\texttt{#1}}}
\newcommand{\colornom}[1]{\renewcommand{\elcolornom}{\color{#1}}}
\newcommand{\colorupvdma}[1]{\renewcommand{\elcolorupvdma}{\color{#1}}}
\newcommand{\coloradreca}[1]{\renewcommand{\elcoloradreca}{\color{#1}}}
\newcommand{\ample}[1]{\setlength{\fminilength}{#1cm}
                       \renewcommand{\lample}{#1}}
\newcommand{\alt}[1]{\setlength{\fminiheight}{#1cm}
                     \renewcommand{\lalt}{#1}}

% Centres (opcional, i nom'es per al Campus de Vera)
\newcommand{\etsea}{\renewcommand{\elcentre}{E.T.S.E. Agr\`onoms}}
\newcommand{\etsei}{\renewcommand{\elcentre}{E.T.S.E. Industrials}}
\newcommand{\etset}{\renewcommand{\elcentre}{E.T.S.E. Telecomunicacions}}
\newcommand{\etsec}{\renewcommand{\elcentre}{E.T.S.E. Camins, C. i P.}}
\newcommand{\etseg}{\renewcommand{\elcentre}{E.T.S.E. Geod\`esica, C. i T.}}
\newcommand{\etsa}{\renewcommand{\elcentre}{E.T.S. Arquitectura}}
\newcommand{\facinf}{\renewcommand{\elcentre}{F. d'Inform\`atica}}
\newcommand{\fba}{\renewcommand{\elcentre}{F. de Belles Arts ``Sant Carles''}}
\newcommand{\fade}{\renewcommand{\elcentre}{F. d'Admin. i Direcci d'Empreses}}
\newcommand{\eueta}{\renewcommand{\elcentre}{E.U.E.T. Agr\'\i cola}}
\newcommand{\eueti}{\renewcommand{\elcentre}{E.U.E.T. Industrial}}
\newcommand{\euat}{\renewcommand{\elcentre}{E.U. Arquitectura T\`ecnica}}
\newcommand{\eui}{\renewcommand{\elcentre}{E. U. d'Inform\`atica}}
% 
\newcommand{\etsia}{\renewcommand{\elcentre}{E.T.S.E. Agr\`onoms}}
\newcommand{\etsii}{\renewcommand{\elcentre}{E.T.S.E. Industrials}}
\newcommand{\etsit}{\renewcommand{\elcentre}{E.T.S.E. Telecomunicacions}}
\newcommand{\etsic}{\renewcommand{\elcentre}{E.T.S.E. Camins, C. i P.}}
\newcommand{\etsig}{\renewcommand{\elcentre}{E.T.S.E. Geod\`esica, C. i T.}}
\newcommand{\euita}{\renewcommand{\elcentre}{E.U.E.T. Agr\'\i cola}}
\newcommand{\euiti}{\renewcommand{\elcentre}{E.U.E.T. Industrial}}

% Campus 
\newcommand{\vera}{\renewcommand\campus{vera}}
\newcommand{\blasco}{\renewcommand\campus{blasco}}
\newcommand{\gandia}{\renewcommand\campus{gandia}}
\newcommand{\alcoi}{\renewcommand\campus{alcoi}}
% Definicions
\newlength{\camidevera}
\newlength{\paginapersonal}
\newlength{\untelefon}
\newcommand{\festargeta}{%
     \begin{fminipage}
       \vspace*{\stretch{1}}
       \begin{center}
           \includegraphics[width=.75\textwidth]{dma.eps}
           \includegraphics[width=.15\textwidth]{miniupv16.eps2}
           \elcolornom
           \Large \elnom\par
           \footnotesize
           \elcarrec\par\smallskip
           \elcolorupvdma
           Universitat Polit\`ecnica de Val\`encia\par
           Departament de Matem\`atica Aplicada
       \end{center}
       \hspace*{\stretch1}
       \elcoloradreca
       \scriptsize
          \ifthenelse{\equal{\campus}{vera}}{% 
            \ifthenelse{\equal{\elcentre}{}}{\settowidth{\camidevera}{%
                                              Cam\'\i{} de Vera, 14}}{%
                                              \settowidth{\camidevera}{%
                                              \elcentre}}
            \begin{minipage}[t]{\camidevera}
                \ifthenelse{\equal{\elcentre}{}}{}{\elcentre\par}
                Cam\'\i{} de Vera, 14\par
                46022 Val\`encia\par
                SPAIN
            \end{minipage}}{}
          \ifthenelse{\equal{\campus}{alcoi}}{% 
            \settowidth{\camidevera}{E. Polit\`ecnica Sup. d'Alcoi}
            \begin{minipage}[t]{\camidevera}
                E. Polit\`ecnica Sup. d'Alcoi\par
                Passeig del Viaducte, 1\par
                03800 Alcoi\par
                SPAIN
            \end{minipage}}{}
          \ifthenelse{\equal{\campus}{blasco}}{% 
            \settowidth{\camidevera}{Av. Blasco Iba\~nez, 21}
            \begin{minipage}[t]{\camidevera}
                E.U.E.T. Agricola\par
                Av. Blasco Iba\~nez, 21\par
                46010 Val\`encia\par
                SPAIN
            \end{minipage}}{}
          \ifthenelse{\equal{\campus}{gandia}}{% 
            \settowidth{\camidevera}{Carretera de Natzaret a Oliva s/n}
            \begin{minipage}[t]{\camidevera}
                E. Polit\`ecnica Sup. de Gandia\par
                Carretera de Natzaret a Oliva s/n\par
                46730 Gandia\par
                SPAIN
            \end{minipage}}{}
            \hfill
            \settowidth{\paginapersonal}{http://ttt.upv.es/\~{}xxxxxxxx}
            \begin{minipage}[t]{\paginapersonal}
            \ifthenelse{\equal{\eltelefon}{}}{}{%
            \settowidth{\untelefon}{999999999 (ext. 9999)}
            tel. \begin{minipage}[t]{\untelefon}
                              \flushleft\eltelefon
                 \end{minipage}\\}
            \ifthenelse{\equal{\elfax}{}}{}{%
            \settowidth{\untelefon}{999999999 (ext. 9999)}
            fax: \begin{minipage}[t]{\untelefon}
                              \flushleft\elfax
                 \end{minipage}\\}
            \ifthenelse{\equal{\lemail}{}}{}{a/e: \lemail\\}
            \ifthenelse{\equal{\lurl}{}}{}{\lurl}
            \end{minipage}
       \hspace*{\stretch1}
       \vspace*{\stretch{1}}
     \end{fminipage}
       }

\newcounter{targetes}
\newcounter{pagines}
\newenvironment{targeta}[1][1]{%
     \newcommand{\numpagines}{#1}
	\setcounter{pagines}{0}
     }{\whiledo{\value{pagines}<\numpagines}{%
		\stepcounter{pagines}\setcounter{targetes}{0}{%
		\whiledo{\value{targetes}<10}{%
			\stepcounter{targetes}\festargeta}\clearpage}
          }}